Code

rebase: remember verbose option
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example:       git-rebase master~1 topic
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 LF='
38 '
39 ok_to_skip_pre_rebase=
40 resolvemsg="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset onto
46 strategy=
47 strategy_opts=
48 do_merge=
49 merge_dir="$GIT_DIR"/rebase-merge
50 apply_dir="$GIT_DIR"/rebase-apply
51 verbose=
52 diffstat=
53 test "$(git config --bool rebase.stat)" = true && diffstat=t
54 git_am_opt=
55 rebase_root=
56 force_rebase=
57 allow_rerere_autoupdate=
58 # Non-empty if a rebase was in progress when 'git rebase' was invoked
59 in_progress=
60 # One of {am, merge, interactive}
61 type=
62 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
63 state_dir=
64 # One of {'', continue, skip, abort}, as parsed from command line
65 action=
66 preserve_merges=
67 autosquash=
68 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
70 read_basic_state () {
71         head_name=$(cat "$state_dir"/head-name) &&
72         onto=$(cat "$state_dir"/onto) &&
73         # We always write to orig-head, but interactive rebase used to write to
74         # head. Fall back to reading from head to cover for the case that the
75         # user upgraded git with an ongoing interactive rebase.
76         if test -f "$state_dir"/orig-head
77         then
78                 orig_head=$(cat "$state_dir"/orig-head)
79         else
80                 orig_head=$(cat "$state_dir"/head)
81         fi &&
82         GIT_QUIET=$(cat "$state_dir"/quiet) &&
83         test -f "$state_dir"/verbose && verbose=t
84 }
86 write_basic_state () {
87         echo "$head_name" > "$state_dir"/head-name &&
88         echo "$onto" > "$state_dir"/onto &&
89         echo "$orig_head" > "$state_dir"/orig-head &&
90         echo "$GIT_QUIET" > "$state_dir"/quiet &&
91         test t = "$verbose" && : > "$state_dir"/verbose
92 }
94 output () {
95         case "$verbose" in
96         '')
97                 output=$("$@" 2>&1 )
98                 status=$?
99                 test $status != 0 && printf "%s\n" "$output"
100                 return $status
101                 ;;
102         *)
103                 "$@"
104                 ;;
105         esac
108 move_to_original_branch () {
109         case "$head_name" in
110         refs/*)
111                 message="rebase finished: $head_name onto $onto"
112                 git update-ref -m "$message" \
113                         $head_name $(git rev-parse HEAD) $orig_head &&
114                 git symbolic-ref HEAD $head_name ||
115                 die "Could not move back to $head_name"
116                 ;;
117         esac
120 run_specific_rebase () {
121         if [ "$interactive_rebase" = implied ]; then
122                 GIT_EDITOR=:
123                 export GIT_EDITOR
124         fi
125         . git-rebase--$type
128 run_pre_rebase_hook () {
129         if test -z "$ok_to_skip_pre_rebase" &&
130            test -x "$GIT_DIR/hooks/pre-rebase"
131         then
132                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
133                 die "The pre-rebase hook refused to rebase."
134         fi
137 test -f "$apply_dir"/applying &&
138         die 'It looks like git-am is in progress. Cannot rebase.'
140 if test -d "$apply_dir"
141 then
142         type=am
143         state_dir="$apply_dir"
144 elif test -d "$merge_dir"
145 then
146         if test -f "$merge_dir"/interactive
147         then
148                 type=interactive
149                 interactive_rebase=explicit
150         else
151                 type=merge
152         fi
153         state_dir="$merge_dir"
154 fi
155 test -n "$type" && in_progress=t
157 total_argc=$#
158 while test $# != 0
159 do
160         case "$1" in
161         --no-verify)
162                 ok_to_skip_pre_rebase=yes
163                 ;;
164         --verify)
165                 ok_to_skip_pre_rebase=
166                 ;;
167         --continue|--skip|--abort)
168                 test $total_argc -eq 1 || usage
169                 action=${1##--}
170                 ;;
171         --onto)
172                 test 2 -le "$#" || usage
173                 onto="$2"
174                 shift
175                 ;;
176         -i|--interactive)
177                 interactive_rebase=explicit
178                 ;;
179         -p|--preserve-merges)
180                 preserve_merges=t
181                 test -z "$interactive_rebase" && interactive_rebase=implied
182                 ;;
183         --autosquash)
184                 autosquash=t
185                 ;;
186         --no-autosquash)
187                 autosquash=
188                 ;;
189         -M|-m|--m|--me|--mer|--merg|--merge)
190                 do_merge=t
191                 ;;
192         -X*|--strategy-option*)
193                 case "$#,$1" in
194                 1,-X|1,--strategy-option)
195                         usage ;;
196                 *,-X|*,--strategy-option)
197                         newopt="$2"
198                         shift ;;
199                 *,--strategy-option=*)
200                         newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
201                 *,-X*)
202                         newopt="$(expr " $1" : ' -X\(.*\)')" ;;
203                 1,*)
204                         usage ;;
205                 esac
206                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
207                 do_merge=t
208                 test -z "$strategy" && strategy=recursive
209                 ;;
210         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
211                 --strateg=*|--strategy=*|\
212         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
213                 case "$#,$1" in
214                 *,*=*)
215                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
216                 1,*)
217                         usage ;;
218                 *)
219                         strategy="$2"
220                         shift ;;
221                 esac
222                 do_merge=t
223                 ;;
224         -n|--no-stat)
225                 diffstat=
226                 ;;
227         --stat)
228                 diffstat=t
229                 ;;
230         -v|--verbose)
231                 verbose=t
232                 diffstat=t
233                 GIT_QUIET=
234                 ;;
235         -q|--quiet)
236                 GIT_QUIET=t
237                 git_am_opt="$git_am_opt -q"
238                 verbose=
239                 diffstat=
240                 ;;
241         --whitespace=*)
242                 git_am_opt="$git_am_opt $1"
243                 case "$1" in
244                 --whitespace=fix|--whitespace=strip)
245                         force_rebase=t
246                         ;;
247                 esac
248                 ;;
249         --ignore-whitespace)
250                 git_am_opt="$git_am_opt $1"
251                 ;;
252         --committer-date-is-author-date|--ignore-date)
253                 git_am_opt="$git_am_opt $1"
254                 force_rebase=t
255                 ;;
256         -C*)
257                 git_am_opt="$git_am_opt $1"
258                 ;;
259         --root)
260                 rebase_root=t
261                 ;;
262         -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
263                 force_rebase=t
264                 ;;
265         --rerere-autoupdate|--no-rerere-autoupdate)
266                 allow_rerere_autoupdate="$1"
267                 ;;
268         -*)
269                 usage
270                 ;;
271         *)
272                 break
273                 ;;
274         esac
275         shift
276 done
277 test $# -gt 2 && usage
279 if test -n "$action"
280 then
281         test -z "$in_progress" && die "No rebase in progress?"
282         # Only interactive rebase uses detailed reflog messages
283         if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
284         then
285                 GIT_REFLOG_ACTION="rebase -i ($action)"
286                 export GIT_REFLOG_ACTION
287         fi
288 fi
290 case "$action" in
291 continue)
292         # Sanity check
293         git rev-parse --verify HEAD >/dev/null ||
294                 die "Cannot read HEAD"
295         git update-index --ignore-submodules --refresh &&
296         git diff-files --quiet --ignore-submodules || {
297                 echo "You must edit all merge conflicts and then"
298                 echo "mark them as resolved using git add"
299                 exit 1
300         }
301         read_basic_state
302         run_specific_rebase
303         ;;
304 skip)
305         output git reset --hard HEAD || exit $?
306         read_basic_state
307         run_specific_rebase
308         ;;
309 abort)
310         git rerere clear
311         read_basic_state
312         case "$head_name" in
313         refs/*)
314                 git symbolic-ref HEAD $head_name ||
315                 die "Could not move back to $head_name"
316                 ;;
317         esac
318         output git reset --hard $orig_head
319         rm -r "$state_dir"
320         exit
321         ;;
322 esac
324 # Make sure no rebase is in progress
325 if test -n "$in_progress"
326 then
327         die '
328 It seems that there is already a '"${state_dir##*/}"' directory, and
329 I wonder if you are in the middle of another rebase.  If that is the
330 case, please try
331         git rebase (--continue | --abort | --skip)
332 If that is not the case, please
333         rm -fr '"$state_dir"'
334 and run me again.  I am stopping in case you still have something
335 valuable there.'
336 fi
338 test $# -eq 0 && test -z "$rebase_root" && usage
340 if test -n "$interactive_rebase"
341 then
342         type=interactive
343         state_dir="$merge_dir"
344 elif test -n "$do_merge"
345 then
346         type=merge
347         state_dir="$merge_dir"
348 else
349         type=am
350         state_dir="$apply_dir"
351 fi
353 if test -z "$rebase_root"
354 then
355         # The upstream head must be given.  Make sure it is valid.
356         upstream_name="$1"
357         shift
358         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
359         die "invalid upstream $upstream_name"
360         upstream_arg="$upstream_name"
361 else
362         test -z "$onto" && die "You must specify --onto when using --root"
363         unset upstream_name
364         unset upstream
365         upstream_arg=--root
366 fi
368 # Make sure the branch to rebase onto is valid.
369 onto_name=${onto-"$upstream_name"}
370 case "$onto_name" in
371 *...*)
372         if      left=${onto_name%...*} right=${onto_name#*...} &&
373                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
374         then
375                 case "$onto" in
376                 ?*"$LF"?*)
377                         die "$onto_name: there are more than one merge bases"
378                         ;;
379                 '')
380                         die "$onto_name: there is no merge base"
381                         ;;
382                 esac
383         else
384                 die "$onto_name: there is no merge base"
385         fi
386         ;;
387 *)
388         onto=$(git rev-parse --verify "${onto_name}^0") ||
389         die "Does not point to a valid commit: $1"
390         ;;
391 esac
393 # If the branch to rebase is given, that is the branch we will rebase
394 # $branch_name -- branch being rebased, or HEAD (already detached)
395 # $orig_head -- commit object name of tip of the branch before rebasing
396 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
397 switch_to=
398 case "$#" in
399 1)
400         # Is it "rebase other $branchname" or "rebase other $commit"?
401         branch_name="$1"
402         switch_to="$1"
404         if git show-ref --verify --quiet -- "refs/heads/$1" &&
405            orig_head=$(git rev-parse -q --verify "refs/heads/$1")
406         then
407                 head_name="refs/heads/$1"
408         elif orig_head=$(git rev-parse -q --verify "$1")
409         then
410                 head_name="detached HEAD"
411         else
412                 echo >&2 "fatal: no such branch: $1"
413                 usage
414         fi
415         ;;
416 *)
417         # Do not need to switch branches, we are already on it.
418         if branch_name=`git symbolic-ref -q HEAD`
419         then
420                 head_name=$branch_name
421                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
422         else
423                 head_name="detached HEAD"
424                 branch_name=HEAD ;# detached
425         fi
426         orig_head=$(git rev-parse --verify "${branch_name}^0") || exit
427         ;;
428 esac
430 require_clean_work_tree "rebase" "Please commit or stash them."
432 # Now we are rebasing commits $upstream..$orig_head (or with --root,
433 # everything leading up to $orig_head) on top of $onto
435 # Check if we are already based on $onto with linear history,
436 # but this should be done only when upstream and onto are the same
437 # and if this is not an interactive rebase.
438 mb=$(git merge-base "$onto" "$orig_head")
439 if test "$type" != interactive && test "$upstream" = "$onto" &&
440         test "$mb" = "$onto" &&
441         # linear history?
442         ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
443 then
444         if test -z "$force_rebase"
445         then
446                 # Lazily switch to the target branch if needed...
447                 test -z "$switch_to" || git checkout "$switch_to" --
448                 say "Current branch $branch_name is up to date."
449                 exit 0
450         else
451                 say "Current branch $branch_name is up to date, rebase forced."
452         fi
453 fi
455 # If a hook exists, give it a chance to interrupt
456 run_pre_rebase_hook "$upstream_arg" "$@"
458 if test -n "$diffstat"
459 then
460         if test -n "$verbose"
461         then
462                 echo "Changes from $mb to $onto:"
463         fi
464         # We want color (if set), but no pager
465         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
466 fi
468 test "$type" = interactive && run_specific_rebase
470 # Detach HEAD and reset the tree
471 say "First, rewinding head to replay your work on top of it..."
472 git checkout -q "$onto^0" || die "could not detach HEAD"
473 git update-ref ORIG_HEAD $orig_head
475 # If the $onto is a proper descendant of the tip of the branch, then
476 # we just fast-forwarded.
477 if test "$mb" = "$orig_head"
478 then
479         say "Fast-forwarded $branch_name to $onto_name."
480         move_to_original_branch
481         exit 0
482 fi
484 if test -n "$rebase_root"
485 then
486         revisions="$onto..$orig_head"
487 else
488         revisions="$upstream..$orig_head"
489 fi
491 run_specific_rebase